<?php
/**
Plugin Name: PZWO LetztesUpdate
Plugin URI: https://pegelzwo.de/wordpress
Description: Dieses Plugin zeigt das Datum und die Uhrzeit der letzten Bearbeting einer Seite oder eines Beitrages an! Shortcodes:  "[letztes-update]" oder "[letztes-update-seitheute]"
Version: 1.1
Author: Martin Kraus
Author URI: https://www.pegelzwo.de
Text Domain: letztes-update
Domain Path: /
License: GPLv3
*/

/**
 * @package Letztes Update
 */

add_shortcode('letztes-update', 'letztesUpdate');
function letztesUpdate() {
  global $wpdb;
  $seiten_id = get_the_id();
  $result = $wpdb->get_var("SELECT UNIX_TIMESTAMP(post_modified) as post_modified FROM $wpdb->posts WHERE post_status = 'publish' AND ID = $seiten_id ORDER BY post_modified DESC LIMIT 1");
  $result = $result + 3600;
  $weekday = strftime( '%u', $result );
      if ($weekday == 1){ $wd = "Montag";} 
  elseif ($weekday == 2){ $wd = "Dienstag";}
  elseif ($weekday == 3){ $wd = "Mittwoch";}
  elseif ($weekday == 4){ $wd = "Donnerstag";}
  elseif ($weekday == 5){ $wd = "Freitag";}
  elseif ($weekday == 6){ $wd = "Samstag";}
  elseif ($weekday == 7){ $wd = "Sonntag";}
  
  $lastmod = "Letzte Aktualisierung: " . $wd .", ". strftime( '%d.%m.%Y - %H:%M', $result ) . " Uhr";  
  return $lastmod;
}

add_shortcode('letztes-update-seitheute', 'letztesUpdateHeute');
function letztesUpdateHeute() {
  global $wpdb;
  $seiten_id = get_the_id();	
  $result = $wpdb->get_var("SELECT UNIX_TIMESTAMP(post_modified) as post_modified FROM $wpdb->posts WHERE post_status = 'publish' AND ID = $seiten_id ORDER BY post_modified DESC LIMIT 1");
  // Zeitzone, Sommer-/Winterzeit korrigieren (1 Stunde = 3600 Sekunden)
  $result = $result + 3600; // Timestamp letzte Aktualisierung
  $jetzt .= strtotime("now"); // Timestamp aktuelle Zeit
  // Timestamp in Datum umwandeln
  $datumVon = strftime( '%d/%m/%Y', $result );
  $datumBis = strftime( '%d/%m/%Y', $jetzt );
  // Rechenbare Formate
  $myArrayDatumVon = explode("/", $datumVon);
  $datumVon = mktime(0,0,0,$myArrayDatumVon[1],$myArrayDatumVon[0],$myArrayDatumVon[2]);
  $myArrayDatumBis = explode("/", $datumBis);
  $datumBis = mktime(0,0,0,$myArrayDatumBis[1],$myArrayDatumBis[0],$myArrayDatumBis[2]);
  // Differenz in Tagen
  $differenztage = ($datumBis-$datumVon) / (3600*24);
  // Ausgabe formatieren, heute, gestern oder vor x Tagen, Wochen, Monaten, Jahr
  if ( $differenztage == 0 ){ $ausgabe = "heute";}
  elseif ( $differenztage == 1 ){ $ausgabe = "gestern";}
  elseif ( $differenztage > 1 OR $differenztage < 7 ){ $ausgabe="vor ".$differenztage." Tagen";}
  elseif ( $differenztage >= 7 ){ $ausgabe = "vor 1 Woche";}
  elseif ( $differenztage >= 14){ $ausgabe = "vor 2 Wochen";}
  elseif ( $differenztage >= 21){ $ausgabe = "vor 3 Wochen";}
  elseif ( $differenztage >= 30){ $ausgabe = "vor 1 Mmonat";}
  elseif ( $differenztage >= 60){ $ausgabe = "vor 2 Monaten";}
  elseif ( $differenztage >= 90){ $ausgabe = "vor 3 Monaten";}
  elseif ( $differenztage >= 120){ $ausgabe = "vor 4 Monaten";}
  elseif ( $differenztage >= 150){ $ausgabe = "vor 5 Monaten";}
  elseif ( $differenztage >= 180){ $ausgabe = "vor 6 Monaten";}
  elseif ( $differenztage >= 210){ $ausgabe = "vor 7 Monaten";}
  elseif ( $differenztage >= 240){ $ausgabe = "vor 8 Monaten";}
  elseif ( $differenztage >= 270){ $ausgabe = "vor 9 Monaten";}
  elseif ( $differenztage >= 300){ $ausgabe = "vor 10 Monaten";}
  elseif ( $differenztage >= 330){ $ausgabe = "vor 11 Monaten";}
  elseif ( $differenztage >= 360){ $ausgabe = "vor 1 Jahr";}
  elseif ( $differenztage >= 390){ $ausgabe = "vor über einem Jahr";}
  else { $ausgabe = "Sorry, Fehler in der Berechnung...";}
  // Ausgabe
  return $ausgabe;
}

?>